Skip to content

REST API Reference

The Life API is HTTP REST interface to the Fulcra Data Platform that Context and other integrations are built on. Fulcra is still an early stage product and we strive to keep stable interfaces, though some API definitions may be subject change and deprecation. We recommend using the Fulcra Python SDK or the Fulcra CLI to interact with the Life API.

Authentication

API requests are authenticated via OAuth 2.0 bearer tokens. The Fulcra CLI provides an easy way to authenticate and update access tokens for use with curl and other clients.

curl --oauth2-bearer $(fulcra auth print-access-token) \
  https://api.fulcradynamics.com/user/v1alpha1/info

Data Queries


GET /data/v0/{fulcra_userid}/apple_location_updates

Retrieve the raw Apple location update samples for the specified user during the specified period of time.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
start_time query string(date-time) true The starting timestamp in ISO 8601 format (inclusive)
end_time query string(date-time) true The ending timestamp in ISO 8601 format (exclusive)

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/apple_location_updates?start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v0/{fulcra_userid}/apple_location_visits

Retrieve the raw Apple location visit samples for the specified user during the specified period of time.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
start_time query string(date-time) true The starting timestamp in ISO 8601 format (inclusive)
end_time query string(date-time) true The ending timestamp in ISO 8601 format (exclusive)

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/apple_location_visits?start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v0/{fulcra_userid}/apple_workouts

Retrieve the Apple workouts that occurred for the user during the specified period of time.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
start_time query string(date-time) true The starting timestamp in ISO 8601 format (inclusive)
end_time query string(date-time) true The ending timestamp in ISO 8601 format (exclusive)

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/apple_workouts?start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

[
  {
    "all_statistics": {},
    "apple_workout_id": "17d1ac31-161c-41b7-bb0c-8c7db70b55d8",
    "device": {},
    "duration": 0,
    "end_date": "2019-08-24T14:15:22Z",
    "extras": {},
    "has_undetermined_duration": true,
    "source_revision": {},
    "start_date": "2019-08-24T14:15:22Z",
    "workout_activities": [
      {}
    ],
    "workout_activity_type": "The type of workout.",
    "workout_events": [
      {}
    ]
  }
]

GET /data/v0/{fulcra_userid}/calendar_events

Returns calendar events for a user.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
start_time query string(date-time) true The starting timestamp in ISO 8601 format (inclusive)
end_time query string(date-time) true The ending timestamp in ISO 8601 format (exclusive)
calendar_ids query any false A list of IDs of calendars to search. Only results from these calendars will be returned.

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/calendar_events?start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

[
  {
    "allow_new_time_proposals": true,
    "availability": "string",
    "calendar_event_id": "7fe777b6-1e25-45fe-a4a1-3723b5fd440f",
    "calendar_id": "c828ce68-4c5a-4491-b76a-af3d888d3f97",
    "calendar_item_external_identifier": "string",
    "calendar_item_identifier": "string",
    "creation_date": "2019-08-24T14:15:22Z",
    "end_date": "2019-08-24T14:15:22Z",
    "event_identifier": "string",
    "extras": {},
    "geolocation": {
      "altitude": 0,
      "ellipsoidal_altitude": 0,
      "floor": 0,
      "horizontal_accuracy": 0,
      "is_produced_by_accessory": true,
      "is_simulated_by_software": true,
      "latitude": 0,
      "location_timestamp": "2019-08-24T14:15:22Z",
      "longitude": 0,
      "radius": 0,
      "title": "string",
      "vertical_accuracy": 0
    },
    "has_alarms": true,
    "has_attendees": true,
    "has_notes": true,
    "has_recurrence_rules": true,
    "is_all_day": true,
    "is_detached": true,
    "last_modified_date": "2019-08-24T14:15:22Z",
    "location": "string",
    "notes": "string",
    "occurrence_date": "2019-08-24T14:15:22Z",
    "organizer": "e28f9b28-e5bc-4a12-aafc-96f3301f7fe0",
    "participants": [
      {
        "contact_id": "f245e2a3-e141-4d41-912c-b1c1f5bd5598",
        "is_current_user": true,
        "name": "string",
        "participant_role": "string",
        "participant_status": "string",
        "participant_type": "string",
        "url": "string"
      }
    ],
    "recurrence_rules": [
      {
        "calendar_id": "c828ce68-4c5a-4491-b76a-af3d888d3f97",
        "days_of_the_month": [
          null
        ],
        "days_of_the_week": [
          null
        ],
        "days_of_the_year": [
          null
        ],
        "first_day_of_the_week": 0,
        "frequency": "string",
        "interval": 0,
        "months_of_the_year": [
          null
        ],
        "recurrence_rule_id": "ff66070e-89d9-4007-ac1d-92d2556a9349",
        "set_positions": [
          null
        ],
        "weeks_of_the_year": [
          null
        ]
      }
    ],
    "start_date": "2019-08-24T14:15:22Z",
    "status": "string",
    "time_zone": "string",
    "title": "string",
    "url": "string"
  }
]

GET /data/v0/{fulcra_userid}/calendars

Retrieve a collection of the user's calendars.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
vendor_ids query any false A list of identifiers (calendar_identifier) of calendars to search. Only results from these calendars will be returned.

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/calendars \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

[
  {
    "calendar_color": "string",
    "calendar_id": "c828ce68-4c5a-4491-b76a-af3d888d3f97",
    "calendar_identifier": "string",
    "calendar_name": "string",
    "calendar_source_id": "string",
    "calendar_source_name": "string",
    "calendar_type": "string",
    "color": "Calendar Color",
    "fulcra_source": "string",
    "inserted_at": "2019-08-24T14:15:22Z",
    "is_immutable": true,
    "is_subscribed": true,
    "source_type": "string"
  }
]

GET /data/v0/{fulcra_userid}/location_at_time

Gets the user's location at the specified time. If no sample is available for the exact time, searches for the closest sample up to window_size seconds back. If include_after is true, then also searches window_size seconds forward.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
time query string(date-time) true The timestamp in ISO 8601 format to request location for
window_size query integer false The amount of time to look back (and forward, if the include_after parameter is true) for a sample.
include_after query boolean false When true, a sample that occurs after the requested time may be returned if it is the closest one.
reverse_geocode query boolean false When true, Fulcra will attempt to reverse geocode the location and include the location details in the results.

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/location_at_time?time=2023-02-01T08%3A00%3A00Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v0/{fulcra_userid}/location_time_series

Retrieve a time series of locations that the user was at.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
start_time query string(date-time) true The starting timestamp in ISO8601 format (inclusive)
end_time query string(date-time) true The ending timestamp in ISO8601 format (exclusive)
sample_rate query integer false The sample rate in seconds.
look_back query integer false The number of seconds in the past to look back for a sample.
change_meters query any false When specified, subsequent samples that are fewer than this many meters away will not be included.
reverse_geocode query boolean false When true, Fulcra will attempt to reverse geocode the locations and include the location details in the results.
location_sources query array[string] false A set of sources to use location samples from.
Enumerated Values
Parameter Value
location_sources ios
location_sources google_maps

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/location_time_series?start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v0/{fulcra_userid}/location_updates

Retrieve the location update samples for the specified user during the specified period of time.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
start_time query string(date-time) true The starting timestamp in ISO 8601 format (inclusive)
end_time query string(date-time) true The ending timestamp in ISO 8601 format (exclusive)
location_sources query array[string] false A set of sources to use location samples from.
Enumerated Values
Parameter Value
location_sources ios
location_sources google_maps

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/location_updates?start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v0/{fulcra_userid}/metric_samples

Retrieve the raw samples related to the given metric that occurred for the user during the specified period of time.

In cases where samples cover ranges and not points in time, a sample will be returned if any part of its range intersects with the requested range.

As an example, if you have start_date as 14:00 and end_date at 15:00, and there is a sample that covers 13:30-14:30, it will be included.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
start_time query string(date-time) true The starting timestamp in ISO 8601 format (inclusive)
end_time query string(date-time) true The ending timestamp in ISO 8601 format (exclusive)
metric query string true The metric to retrieve samples for.

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/metric_samples?start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z&metric=HeartRate' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v0/{fulcra_userid}/metric_time_series

Retrieve a time-series dataframe containing one metric.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
start_time query string(date-time) true The starting timestamp in ISO8601 format (inclusive)
end_time query string(date-time) true The ending timestamp in ISO8601 format (exclusive)
metric query string true The metric to retrieve data for.
output query OutputMethod true The output format to generate.
samprate query any false The sample rate in seconds or in the polars string language (see https://docs.pola.rs/api/python/dev/reference/expressions/api/polars.Expr.dt.truncate.html).
replace_nulls query any false Set to 1 to replace all unavailable values with 0.
calculations query any false Additional statistics to calculate for each time window.
drop_nulls query any false When set to 1, all null samples are removed.
tz query any false IANA time zone to return results in
Enumerated Values
Parameter Value
output ndjson
output jstable
output jscolumns
output arrow
output arrowraw
output parquet
output csv
output quotecsv

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/metric_time_series?start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z&metric=HeartRate&output=ndjson' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v0/{fulcra_userid}/sleep_agg

Process raw sleep data samples aggregated sleep stage durations per period.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
start_time query string(date-time) true The starting timestamp in ISO8601 format (inclusive)
end_time query string(date-time) true The ending timestamp in ISO8601 format (exclusive)
output query OutputMethod true The output format to generate.
cycle_gap query string(duration) false Minimum time interval separating distinct cycles.
stages query any false Sleep stages to include. Defaults to all stages.
gap_stages query any false Sleep stages to consider as gaps in sleep cycles.
clip_to_range query boolean false Whether to clip the data to the requested date range. This is always done when requesting data for a user other than the authenticated user.
mode query Mode false Whether to use the cycle start or cycle end to assign cycles to periods, or to split sleep stage intervals at period boundries.
period query string false The period start and interval represented with the polars string language (see https://docs.pola.rs/api/python/dev/reference/expressions/api/polars.Expr.dt.truncate.html).
agg_functions query array[string] false Aggregations to return.
tz query string false IANA time zone to return results in
Enumerated Values
Parameter Value
output ndjson
output jstable
output jscolumns
output arrow
output arrowraw
output parquet
output csv
output quotecsv
mode start
mode end
mode split
agg_functions sum
agg_functions avg
agg_functions min
agg_functions max

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/sleep_agg?start_time=2024-11-15%2000%3A00%3A00Z&end_time=2024-11-16%2000%3A00%3A00Z&output=ndjson' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v0/{fulcra_userid}/sleep_cycles

Process raw sleep data samples into sleep cycles and assign by finding gaps in the sleep sample data within a specified time interval.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
start_time query string(date-time) true The starting timestamp in ISO8601 format (inclusive)
end_time query string(date-time) true The ending timestamp in ISO8601 format (exclusive)
output query OutputMethod true The output format to generate.
cycle_gap query string(duration) false Minimum time interval separating distinct cycles.
stages query any false Sleep stages to include. Defaults to all stages.
gap_stages query any false Sleep stages to consider as gaps in sleep cycles.
clip_to_range query boolean false Whether to clip the data to the requested date range. This is always done when requesting data for a user other than the authenticated user.
Enumerated Values
Parameter Value
output ndjson
output jstable
output jscolumns
output arrow
output arrowraw
output parquet
output csv
output quotecsv

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/sleep_cycles?start_time=2024-11-15%2000%3A00%3A00Z&end_time=2024-11-16%2000%3A00%3A00Z&output=ndjson' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v0/{fulcra_userid}/sleep_cycles_extended

Extended version of sleep_cycles endpoint for experimentation. Adds metric time series data (heart rate, respiratory rate, etc.) to each sleep cycle.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
start_time query string(date-time) true The starting timestamp in ISO8601 format (inclusive)
end_time query string(date-time) true The ending timestamp in ISO8601 format (exclusive)
output query OutputMethod true The output format to generate.
cycle_gap query string(duration) false Minimum time interval separating distinct cycles.
stages query any false Sleep stages to include. Defaults to all stages.
gap_stages query any false Sleep stages to consider as gaps in sleep cycles.
clip_to_range query boolean false Whether to clip the data to the requested date range. This is always done when requesting data for a user other than the authenticated user.
metrics query any false Optional list of metrics to include as time series data (e.g., HeartRate, RespiratoryRate).
metric_calculations query any false Statistics to calculate for each time window in metric time series.
metric_seconds_before query number false Number of seconds before each sleep cycle to include in metric time series data.
metric_seconds_after query number false Number of seconds after each sleep cycle to include in metric time series data.
Enumerated Values
Parameter Value
output ndjson
output jstable
output jscolumns
output arrow
output arrowraw
output parquet
output csv
output quotecsv

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/sleep_cycles_extended?start_time=2024-11-15%2000%3A00%3A00Z&end_time=2024-11-16%2000%3A00%3A00Z&output=ndjson' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v0/{fulcra_userid}/sleep_stage_metadata

Retrieve metadata for interpreting sleep stage data, such as stage names and depths. In future, this may include user-specific stage or device priorities as well.

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/sleep_stage_metadata \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v0/{fulcra_userid}/sleep_stages

Process raw sleep data samples into non-conflicting sleep stages and assign a cycle index by finding gaps in the sleep sample data within a specified time interval.

If more than one sleep data source is present, sleep stage is determined based on the priority of the stage (in bed and unknown are deprioritized) and the start time of the sample (latest takes precedence)

Request

Parameters
Name In Type Required Description
fulcra_userid path string(uuid) true none
start_time query string(date-time) true The starting timestamp in ISO8601 format (inclusive)
end_time query string(date-time) true The ending timestamp in ISO8601 format (exclusive)
output query OutputMethod true The output format to generate.
cycle_gap query string(duration) false Minimum time interval separating distinct cycles.
stages query any false Sleep stages to include. Defaults to all stages.
gap_stages query any false Sleep stages to consider as gaps in sleep cycles.
merge_overlapping query boolean false Whether to merge overlapping stages based on priority and start time: stage 0 (in bed) has lower priority than other stages; stage 2 (unknown sleep stage) has lower priority than other stages except 0; then stages with later start times take precedece.
merge_contiguous query boolean false Whether to merge contiguous samples with the same sleep stage into one continues stage.
clip_to_range query boolean false Whether to clip the data to the requested date range. This is always done when requesting data for a user other than the authenticated user.
Enumerated Values
Parameter Value
output ndjson
output jstable
output jscolumns
output arrow
output arrowraw
output parquet
output csv
output quotecsv

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v0/497f6eca-6276-4993-bfeb-53cbbbba6f08/sleep_stages?start_time=2024-11-15%2000%3A00%3A00Z&end_time=2024-11-16%2000%3A00%3A00Z&output=ndjson' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v1/catalog

Catalog of Fulcra Data Types

Request

Parameters
Name In Type Required Description
data_type query any false none
category query any false none
fulcra_userid query any false none

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/data/v1/catalog \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

[
  {
    "api_version": "v0",
    "categories": [
      "annotations"
    ],
    "class": "metric",
    "column_name": "string",
    "deprecated": false,
    "description": "string",
    "fulcra_userid": "6e1fcc12-f3a1-4884-be2b-1cd76a63afb7",
    "icon": "string",
    "id": "string",
    "metric_kind": "cumulative",
    "name": "string",
    "queryable": true,
    "record_spec": {
      "schema": {},
      "type": "event"
    },
    "recordable": true,
    "unit": "string"
  }
]

GET /data/v1/catalog/{data_type}/{api_version}

Return metadata for a data type

Request

Parameters
Name In Type Required Description
data_type path string true none
api_version path FulcraAPIVersion true none
fulcra_userid query any false none
Enumerated Values
Parameter Value
api_version v0
api_version v1alpha1
api_version v1

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/data/v1/catalog/string/v0 \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{}

GET /data/v1/catalog/{data_type}/{api_version}/schema

Return record JSON Schema for a data type

Request

Parameters
Name In Type Required Description
data_type path string true none
api_version path FulcraAPIVersion true none
fulcra_userid query any false none
Enumerated Values
Parameter Value
api_version v0
api_version v1alpha1
api_version v1

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/data/v1/catalog/string/v0/schema \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v1/records

Return records for a data type

Takes a compact subset of PromQL and returns individual records for a data type.

The subset of PromQL supports:

  • Instant and Range Vector Selectors
  • @ and offset modifiers
  • = and != label matchers on id, tag, and source
  • Matcher grouping on or
  • last_over_time() over a Range Vector, returning only the most recent matching record in the range

User-defined data types are queried with a __name__ matcher, since PromQL metric names can't contain /: {__name__="Event/<uuid>"}[1d]. Other matchers combine with it as usual ({__name__="Event/<uuid>", tag="..."}); with or, repeat the __name__ matcher in every group.

Instant Vectors deviate from typical Prometheus behavior. An un-anchored Instant Vector will return the latest record with an infinite lookback window. Anchored Instant Vectors return any records that match or fall within a duration.

Returned record schema for individual data types is available from the catalog API: data/v1/catalog/{data_type}/v1/schema

Request

Parameters
Name In Type Required Description
fulcra_userid query any false User ID of the Fulcra User to query records for
format query ResponseFormat false Format to return records in
q query string true PromQL query
Enumerated Values
Parameter Value
format json
format csv

Responses

Status Meaning Description Schema
200 OK Successful Response None
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v1/records?q=HeartRate%5B5m%5D' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

422 Response

{
  "detail": [
    {
      "ctx": {},
      "input": null,
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

GET /data/v1/updates

Available Data Updated For Time Range

Request

Parameters
Name In Type Required Description
start_time query string(date-time) true The starting timestamp in ISO8601 format (inclusive)
end_time query string(date-time) true The ending timestamp ISO8601 format (exclusive)
fulcra_userid query any false none

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v1/updates?start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{}

GET /data/v1alpha1/event/{data_type}

Return records from a Fulcra Data Type

Request

Parameters
Name In Type Required Description
data_type path string true none
start_time query string(date-time) true The starting timestamp in ISO8601 format (inclusive)
end_time query string(date-time) true The ending timestamp ISO8601 format (exclusive)
format query ResponseFormat false Response format (json or csv)
sort query SortOrder false Sort Order
fulcra_userid query any false User ID of Fulcra User to return data for
pool_id query any false Pool ID to return data for
participant_id query any false Pool participant ID to return data for
filter query array[string] false Additional fields to filter by
Enumerated Values
Parameter Value
format json
format csv
sort asc
sort desc

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v1alpha1/event/string?start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v1alpha1/event/{data_type}/agg/{resolution}

Return aggregated data for a Fulcra Metric

Request

Parameters
Name In Type Required Description
resolution path AggregateResolution true Time granularity to aggregate by
data_type path string true none
start_time query string(date-time) true The starting timestamp in ISO8601 format (inclusive)
end_time query string(date-time) true The ending timestamp ISO8601 format (exclusive)
time_zone query TimeZone false IANA time zone to aggregate by
format query ResponseFormat false Response format (json or csv)
sort query SortOrder false Sort Order
fulcra_userid query any false User ID of Fulcra User to return data for
pool_id query any false Pool ID to return data for
participant_id query any false Pool participant ID to return data for
filter query array[string] false Additional fields to filter by
group query array[string] false Additional fields to group by
Enumerated Values
Parameter Value
resolution 15m
resolution 60m
resolution day
format json
format csv
sort asc
sort desc

time_zone: accepts one of 599 values (e.g. Europe/Dublin). See the full list in the OpenAPI specification.

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v1alpha1/event/string/agg/15m?start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v1alpha1/insight

Return insights data

Request

Parameters
Name In Type Required Description
timestamp query any false The timestamp in ISO8601 format (inclusive)
version query InsightReportVersion false Insights report version
Enumerated Values
Parameter Value
version v0

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/data/v1alpha1/insight \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v1alpha1/metric/{data_type}

Return raw samples of a Fulcra Metric

Request

Parameters
Name In Type Required Description
data_type path string true none
start_time query string(date-time) true The starting timestamp in ISO8601 format (inclusive)
end_time query string(date-time) true The ending timestamp ISO8601 format (exclusive)
format query ResponseFormat false Response format (json or csv)
sort query SortOrder false Sort Order
fulcra_userid query any false User ID of Fulcra User to return data for
pool_id query any false Pool ID to return data for
participant_id query any false Pool participant ID to return data for
filter query array[string] false Additional fields to filter by
Enumerated Values
Parameter Value
format json
format csv
sort asc
sort desc

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v1alpha1/metric/string?start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

GET /data/v1alpha1/metric/{data_type}/agg/{resolution}

Return aggregated data for a Fulcra Metric

Request

Parameters
Name In Type Required Description
resolution path AggregateResolution true Time granularity to aggregate by
data_type path string true none
function query array[string] true Aggregate function
start_time query string(date-time) true The starting timestamp in ISO8601 format (inclusive)
end_time query string(date-time) true The ending timestamp ISO8601 format (exclusive)
time_zone query TimeZone false IANA time zone to aggregate by
format query ResponseFormat false Response format (json or csv)
sort query SortOrder false Sort Order
fulcra_userid query any false User ID of Fulcra User to return data for
pool_id query any false Pool ID to return data for
participant_id query any false Pool participant ID to return data for
filter query array[string] false Additional fields to filter by
group query array[string] false Additional fields to group by
Enumerated Values
Parameter Value
resolution 15m
resolution 60m
resolution day
function sum
function avg
function min
function max
format json
format csv
sort asc
sort desc

time_zone: accepts one of 599 values (e.g. Europe/Dublin). See the full list in the OpenAPI specification.

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/data/v1alpha1/metric/string/agg/15m?function=sum&start_time=2023-02-01%2000%3A00%3A00Z&end_time=2023-02-03%2000%3A00%3A00Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

null

Ingestion


POST /ingest/v1/record/{data_type}

Ingest records for a Fulcra data type. Data types can be retrieved from the /data/v1/catalog endpoint. Record schema for a data type can be retrieved from the /data/v1/catalog/{data_type}/{api_version}/schema endpoint.

Request

Request Body
{}
Parameters
Name In Type Required Description
data_type path string true none
api_version query any false none
content-length header integer true none
body body object true none

Responses

Status Meaning Description Schema
201 Created Successful Response UploadResponse
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request POST \
  --url https://api-dev.fulcradynamics.com/ingest/v1/record/string \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}' \
  --header 'Content-Type: application/json' \
  --header 'content-length: 0' \
  --data '{}'

Response Example

201 Response

{
  "upload_id": "f2ef591b-135b-46fa-a604-3d4fda5bfbfb"
}

Data Types


GET /input/v1/data_type

Return a list of user defined data types

Request

Parameters
Name In Type Required Description
include_deprecated query boolean false Include deprecated data types
base_type query string false Filter by base type (e.g. Event, Metric)

Responses

Status Meaning Description Schema
200 OK OK array,null
default Default Error ErrorModel

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/input/v1/data_type \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

[
  {
    "api_version": "string",
    "categories": [
      "string"
    ],
    "column_name": "string",
    "deprecated": true,
    "description": "string",
    "icon": "string",
    "id": "string",
    "metadata": {
      "property1": null,
      "property2": null
    },
    "name": "string",
    "queryable": true,
    "record_spec": {
      "aggregation": "string",
      "scale": {
        "max": 0,
        "min": 0,
        "step": 0
      },
      "schema": "string",
      "type": "string",
      "unit": "string",
      "value_map": {
        "property1": "string",
        "property2": "string"
      }
    },
    "recordable": true
  }
]

POST /input/v1/data_type/{base_type}

Create a user defined data type

Request

Request Body
{
  "api_version": "string",
  "categories": [
    "string"
  ],
  "column_name": "string",
  "deprecated": true,
  "description": "string",
  "icon": "string",
  "id": "string",
  "metadata": {
    "property1": null,
    "property2": null
  },
  "name": "string",
  "queryable": true,
  "record_spec": {
    "aggregation": "cumulative",
    "scale": {
      "max": 0,
      "min": 0,
      "step": 0
    },
    "schema": "string",
    "type": "string",
    "unit": "string",
    "value_map": {
      "property1": "string",
      "property2": "string"
    }
  },
  "recordable": true
}
Parameters
Name In Type Required Description
base_type path string true Base record type (matches the catalog's casing, e.g. Event, Metric)
body body CreateDataTypeBody true none
Enumerated Values
Parameter Value
base_type Event
base_type Metric

Responses

Status Meaning Description Schema
303 See Other See Other None
default Default Error ErrorModel
Response Headers
Status Header Type Format Description
303 Location string none

Examples

Request Example

curl --request POST \
  --url https://api-dev.fulcradynamics.com/input/v1/data_type/Event \
  --header 'Accept: application/problem+json' \
  --header 'Authorization: Bearer {access-token}' \
  --header 'Content-Type: application/json' \
  --data '{"api_version":"string","categories":["string"],"column_name":"string","deprecated":true,"description":"string","icon":"string","id":"string","metadata":{"property1":null,"property2":null},"name":"string","queryable":true,"record_spec":{"aggregation":"cumulative","scale":{"max":0,"min":0,"step":0},"schema":"string","type":"string","unit":"string","value_map":{"property1":"string","property2":"string"}},"recordable":true}'

Response Example

default Response

{
  "detail": "Property foo is required but is missing.",
  "errors": [
    {
      "location": "string",
      "message": "string",
      "value": null
    }
  ],
  "instance": "https://example.com/error-log/abc123",
  "status": 400,
  "title": "Bad Request",
  "type": "https://example.com/errors/example"
}

GET /input/v1/data_type/{base_type}/{data_type_id}

Return a user defined data type

Responses

Status Meaning Description Schema
200 OK OK DataTypeSpec
default Default Error ErrorModel

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/input/v1/data_type// \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{
  "api_version": "string",
  "categories": [
    "string"
  ],
  "column_name": "string",
  "deprecated": true,
  "description": "string",
  "icon": "string",
  "id": "string",
  "metadata": {
    "property1": null,
    "property2": null
  },
  "name": "string",
  "queryable": true,
  "record_spec": {
    "aggregation": "string",
    "scale": {
      "max": 0,
      "min": 0,
      "step": 0
    },
    "schema": "string",
    "type": "string",
    "unit": "string",
    "value_map": {
      "property1": "string",
      "property2": "string"
    }
  },
  "recordable": true
}

PUT /input/v1/data_type/{base_type}/{data_type_id}

Update a user defined data type

Request

Request Body
{
  "deprecated": true,
  "description": "string",
  "icon": "string",
  "name": "string",
  "record_spec": {
    "aggregation": "cumulative",
    "scale": {
      "max": 0,
      "min": 0,
      "step": 0
    },
    "schema": "string",
    "type": "string",
    "unit": "string",
    "value_map": {
      "property1": "string",
      "property2": "string"
    }
  }
}
Parameters
Name In Type Required Description
body body UpdateDataTypeBody true none

Responses

Status Meaning Description Schema
303 See Other See Other None
default Default Error ErrorModel
Response Headers
Status Header Type Format Description
303 Location string none

Examples

Request Example

curl --request PUT \
  --url https://api-dev.fulcradynamics.com/input/v1/data_type// \
  --header 'Accept: application/problem+json' \
  --header 'Authorization: Bearer {access-token}' \
  --header 'Content-Type: application/json' \
  --data '{"deprecated":true,"description":"string","icon":"string","name":"string","record_spec":{"aggregation":"cumulative","scale":{"max":0,"min":0,"step":0},"schema":"string","type":"string","unit":"string","value_map":{"property1":"string","property2":"string"}}}'

Response Example

default Response

{
  "detail": "Property foo is required but is missing.",
  "errors": [
    {
      "location": "string",
      "message": "string",
      "value": null
    }
  ],
  "instance": "https://example.com/error-log/abc123",
  "status": 400,
  "title": "Bad Request",
  "type": "https://example.com/errors/example"
}

Files


GET /input/v1/file

Return a list of file upload inputs

Request

Parameters
Name In Type Required Description
path query string false none
name query string false none
state query array,null false none
include_archived query boolean false none
include_deleted query boolean false none
start_time query string(date-time) false none
end_time query string(date-time) false none
fulcra_userid query string false none
Enumerated Values
Parameter Value
state created
state uploaded
state archived
state deleted

Responses

Status Meaning Description Schema
200 OK OK ListFileUploadResponseBody
default Default Error ErrorModel

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/input/v1/file \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{
  "files": [
    {
      "archived_at": "2019-08-24T14:15:22Z",
      "created_at": "2019-08-24T14:15:22Z",
      "deleted_at": "2019-08-24T14:15:22Z",
      "fulcra_userid": "string",
      "id": "string",
      "last_scanned": "2019-08-24T14:15:22Z",
      "name": "string",
      "path": "string",
      "restored_from_id": "string",
      "scan_state": "string",
      "size": 0,
      "source_data_types": [
        {
          "data_type": "string",
          "state": "string"
        }
      ],
      "source_id": "string",
      "source_name": "string",
      "state": "string",
      "uploaded_at": "2019-08-24T14:15:22Z"
    }
  ],
  "folders": [
    "string"
  ]
}

POST /input/v1/file

Create a file upload input

Request

Request Body
{
  "content_length": 0,
  "content_type": "string",
  "name": "string",
  "path": "string"
}
Parameters
Name In Type Required Description
origin header string false none
body body CreateFileUploadRequestBody true none

Responses

Status Meaning Description Schema
200 OK OK CreateFileUploadResponseBody
default Default Error ErrorModel

Examples

Request Example

curl --request POST \
  --url https://api-dev.fulcradynamics.com/input/v1/file \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}' \
  --header 'Content-Type: application/json' \
  --header 'origin: string' \
  --data '{"content_length":0,"content_type":"string","name":"string","path":"string"}'

Response Example

200 Response

{
  "file": {
    "archived_at": "2019-08-24T14:15:22Z",
    "created_at": "2019-08-24T14:15:22Z",
    "deleted_at": "2019-08-24T14:15:22Z",
    "fulcra_userid": "string",
    "id": "string",
    "last_scanned": "2019-08-24T14:15:22Z",
    "name": "string",
    "path": "string",
    "restored_from_id": "string",
    "scan_state": "string",
    "size": 0,
    "source_data_types": [
      {
        "data_type": "string",
        "state": "string"
      }
    ],
    "source_id": "string",
    "source_name": "string",
    "state": "string",
    "uploaded_at": "2019-08-24T14:15:22Z"
  },
  "url": "string"
}

GET /input/v1/file/recent_changes

Return a list of recent file changes

Request

Parameters
Name In Type Required Description
path query string false none
name query string false none
start_time query string(date-time) true none
end_time query string(date-time) true none

Responses

Status Meaning Description Schema
200 OK OK RecentChangesResponseBody
default Default Error ErrorModel

Examples

Request Example

curl --request GET \
  --url 'https://api-dev.fulcradynamics.com/input/v1/file/recent_changes?start_time=2019-08-24T14%3A15%3A22Z&end_time=2019-08-24T14%3A15%3A22Z' \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{
  "files": [
    {
      "archived_at": "2019-08-24T14:15:22Z",
      "deleted_at": "2019-08-24T14:15:22Z",
      "full_name": "string",
      "id": "string",
      "last_scanned": "2019-08-24T14:15:22Z",
      "scan_state": "string",
      "size": 0,
      "state": "string",
      "uploaded_at": "2019-08-24T14:15:22Z"
    }
  ]
}

DELETE /input/v1/file/{input_id}

Delete a file upload input

Responses

Status Meaning Description Schema
204 No Content No Content None
default Default Error ErrorModel

Examples

Request Example

curl --request DELETE \
  --url https://api-dev.fulcradynamics.com/input/v1/file/ \
  --header 'Accept: application/problem+json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

default Response

{
  "detail": "Property foo is required but is missing.",
  "errors": [
    {
      "location": "string",
      "message": "string",
      "value": null
    }
  ],
  "instance": "https://example.com/error-log/abc123",
  "status": 400,
  "title": "Bad Request",
  "type": "https://example.com/errors/example"
}

GET /input/v1/file/{input_id}

Return a file upload input

Request

Parameters
Name In Type Required Description
fulcra_userid query string false none

Responses

Status Meaning Description Schema
200 OK OK FulcraFileUploadInput
default Default Error ErrorModel

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/input/v1/file/ \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{
  "archived_at": "2019-08-24T14:15:22Z",
  "created_at": "2019-08-24T14:15:22Z",
  "deleted_at": "2019-08-24T14:15:22Z",
  "fulcra_userid": "string",
  "id": "string",
  "last_scanned": "2019-08-24T14:15:22Z",
  "name": "string",
  "path": "string",
  "restored_from_id": "string",
  "scan_state": "string",
  "size": 0,
  "source_data_types": [
    {
      "data_type": "string",
      "state": "string"
    }
  ],
  "source_id": "string",
  "source_name": "string",
  "state": "string",
  "uploaded_at": "2019-08-24T14:15:22Z"
}

GET /input/v1/file/{input_id}/download

Download a file upload input

Request

Parameters
Name In Type Required Description
fulcra_userid query string false none

Responses

Status Meaning Description Schema
200 OK OK None
default Default Error ErrorModel

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/input/v1/file//download \
  --header 'Accept: application/problem+json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

default Response

{
  "detail": "Property foo is required but is missing.",
  "errors": [
    {
      "location": "string",
      "message": "string",
      "value": null
    }
  ],
  "instance": "https://example.com/error-log/abc123",
  "status": 400,
  "title": "Bad Request",
  "type": "https://example.com/errors/example"
}

POST /input/v1/file/{input_id}/restore

Restore an archived file upload input

Responses

Status Meaning Description Schema
200 OK OK FulcraFileUploadInput
default Default Error ErrorModel

Examples

Request Example

curl --request POST \
  --url https://api-dev.fulcradynamics.com/input/v1/file//restore \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{
  "archived_at": "2019-08-24T14:15:22Z",
  "created_at": "2019-08-24T14:15:22Z",
  "deleted_at": "2019-08-24T14:15:22Z",
  "fulcra_userid": "string",
  "id": "string",
  "last_scanned": "2019-08-24T14:15:22Z",
  "name": "string",
  "path": "string",
  "restored_from_id": "string",
  "scan_state": "string",
  "size": 0,
  "source_data_types": [
    {
      "data_type": "string",
      "state": "string"
    }
  ],
  "source_id": "string",
  "source_name": "string",
  "state": "string",
  "uploaded_at": "2019-08-24T14:15:22Z"
}

Annotations


GET /user/v1alpha1/annotation

Return a list of the user's annotations

Request

Parameters
Name In Type Required Description
fulcra_userid query any false none
annotation_type query any false none

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/annotation \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

[
  {
    "annotation_type": "duration",
    "created_at": "2019-08-24T14:15:22Z",
    "deleted_at": "2019-08-24T14:15:22Z",
    "description": "string",
    "fulcra_source_id": "string",
    "fulcra_userid": "6e1fcc12-f3a1-4884-be2b-1cd76a63afb7",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "measurement_spec": {
      "boolean": {
        "value": true
      },
      "measurement_type": "boolean",
      "metric_kind": "cumulative",
      "unit": null,
      "value_type": "boolean"
    },
    "name": "string",
    "spec": {
      "default_note": "string",
      "scale": {
        "label_mapping": {
          "mapping_type": "string",
          "string": {
            "mapping": {
              "property1": "string",
              "property2": "string"
            }
          }
        },
        "scale_mapping": {
          "color": {
            "mapping": {
              "property1": "string",
              "property2": "string"
            }
          },
          "mapping_type": "color"
        }
      }
    },
    "tags": [
      "497f6eca-6276-4993-bfeb-53cbbbba6f08"
    ],
    "updated_at": "2019-08-24T14:15:22Z"
  }
]

POST /user/v1alpha1/annotation

Create a new annotation

Request

Request Body
{
  "annotation_type": "boolean",
  "description": "string",
  "measurement_spec": {
    "boolean": {
      "value": true
    },
    "measurement_type": "boolean",
    "metric_kind": "cumulative",
    "unit": null,
    "value_type": "boolean"
  },
  "name": "string",
  "spec": {
    "default_note": "string"
  },
  "tags": [
    "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  ]
}
Parameters
Name In Type Required Description
response_class query any false none
body body AnnotationRoot true none

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request POST \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/annotation \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}' \
  --header 'Content-Type: application/json' \
  --data '{"annotation_type":"boolean","description":"string","measurement_spec":{"boolean":{"value":true},"measurement_type":"boolean","metric_kind":"cumulative","unit":null,"value_type":"boolean"},"name":"string","spec":{"default_note":"string"},"tags":["497f6eca-6276-4993-bfeb-53cbbbba6f08"]}'

Response Example

200 Response

null

DELETE /user/v1alpha1/annotation/{annotation_id}

Sets the annotation status to deleted

Request

Parameters
Name In Type Required Description
annotation_id path string(uuid) true none
fulcra_userid query any false none

Responses

Status Meaning Description Schema
204 No Content Successful Response None
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request DELETE \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/annotation/497f6eca-6276-4993-bfeb-53cbbbba6f08 \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

422 Response

{
  "detail": [
    {
      "ctx": {},
      "input": null,
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

GET /user/v1alpha1/annotation/{annotation_id}

Return a specific annotation

Request

Parameters
Name In Type Required Description
annotation_id path string(uuid) true none
fulcra_userid query any false none

Responses

Status Meaning Description Schema
200 OK Successful Response AnnotationRow
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/annotation/497f6eca-6276-4993-bfeb-53cbbbba6f08 \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{
  "annotation_type": "duration",
  "created_at": "2019-08-24T14:15:22Z",
  "deleted_at": "2019-08-24T14:15:22Z",
  "description": "string",
  "fulcra_source_id": "string",
  "fulcra_userid": "6e1fcc12-f3a1-4884-be2b-1cd76a63afb7",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "measurement_spec": {
    "boolean": {
      "value": true
    },
    "measurement_type": "boolean",
    "metric_kind": "cumulative",
    "unit": null,
    "value_type": "boolean"
  },
  "name": "string",
  "spec": {
    "default_note": "string",
    "scale": {
      "label_mapping": {
        "mapping_type": "string",
        "string": {
          "mapping": {
            "property1": "string",
            "property2": "string"
          }
        }
      },
      "scale_mapping": {
        "color": {
          "mapping": {
            "property1": "string",
            "property2": "string"
          }
        },
        "mapping_type": "color"
      }
    }
  },
  "tags": [
    "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  ],
  "updated_at": "2019-08-24T14:15:22Z"
}

PUT /user/v1alpha1/annotation/{annotation_id}

Update an existing annotation

Request

Request Body
{
  "annotation_type": "boolean",
  "description": "string",
  "measurement_spec": {
    "boolean": {
      "value": true
    },
    "measurement_type": "boolean",
    "metric_kind": "cumulative",
    "unit": null,
    "value_type": "boolean"
  },
  "name": "string",
  "spec": {
    "default_note": "string"
  },
  "tags": [
    "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  ]
}
Parameters
Name In Type Required Description
annotation_id path string(uuid) true none
fulcra_userid query any false none
body body AnnotationRoot true none

Responses

Status Meaning Description Schema
307 Temporary Redirect Successful Response None
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request PUT \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/annotation/497f6eca-6276-4993-bfeb-53cbbbba6f08 \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}' \
  --header 'Content-Type: application/json' \
  --data '{"annotation_type":"boolean","description":"string","measurement_spec":{"boolean":{"value":true},"measurement_type":"boolean","metric_kind":"cumulative","unit":null,"value_type":"boolean"},"name":"string","spec":{"default_note":"string"},"tags":["497f6eca-6276-4993-bfeb-53cbbbba6f08"]}'

Response Example

422 Response

{
  "detail": [
    {
      "ctx": {},
      "input": null,
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

POST /user/v1alpha1/annotation/{annotation_id}/cancel_deletion

Sets the annotation status to active

Request

Parameters
Name In Type Required Description
annotation_id path string(uuid) true none
fulcra_userid query any false none

Responses

Status Meaning Description Schema
307 Temporary Redirect Successful Response None
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request POST \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/annotation/497f6eca-6276-4993-bfeb-53cbbbba6f08/cancel_deletion \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

422 Response

{
  "detail": [
    {
      "ctx": {},
      "input": null,
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

GET /user/v1alpha1/schema/annotation

Return the annoation model schema in JSON schema format

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/schema/annotation \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{}

GET /user/v1alpha1/schema/measurement

Return the measurement model schema in JSON schema format

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/schema/measurement \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{}

Users


GET /user/v1alpha1/info

Returns information for the authenticated Fulcra user including current preferences (time zone, calendars, etc).

Request

Parameters
Name In Type Required Description
platform query any false none

Responses

Status Meaning Description Schema
200 OK Successful Response V1Alpha1UserResponse
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/info \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{
  "created": "2019-08-24T14:15:22Z",
  "intercom_token": "string",
  "preferences": {
    "calendar_events_data_track_filter_map": {
      "property1": [
        "string"
      ],
      "property2": [
        "string"
      ]
    },
    "calendars": [
      "string"
    ],
    "location_resolution": {
      "property1": 0,
      "property2": 0
    },
    "periods_of_day": {
      "afternoon": "12:00:00",
      "end_of_day": "21:00:00",
      "evening": "18:00:00",
      "morning": "08:00:00"
    },
    "pinned_metrics_count_map": {
      "property1": 0,
      "property2": 0
    },
    "selected_calendar_vendor_ids": [
      "string"
    ],
    "selected_metrics": [
      "string"
    ],
    "selected_metrics_map": {
      "property1": [
        "string"
      ],
      "property2": [
        "string"
      ]
    },
    "timezone": "string"
  },
  "service_status": {
    "active_until": "2019-08-24T14:15:22Z",
    "grace_period_ends": "2019-08-24T14:15:22Z",
    "is_active": true,
    "manage_url": "string",
    "service_type": "subscribed_apple"
  },
  "status": "string",
  "tier": "string",
  "userid": "4c3716c4-7217-4d1b-b0ed-f18a56ef1093"
}

GET /user/v1alpha1/preferences

Return the current preferences and settings for the authenticated Fulcra user

Responses

Status Meaning Description Schema
200 OK Successful Response FulcraUserPreferences
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/preferences \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{
  "calendar_events_data_track_filter_map": {
    "property1": [
      "string"
    ],
    "property2": [
      "string"
    ]
  },
  "calendars": [
    "string"
  ],
  "location_resolution": {
    "property1": 0,
    "property2": 0
  },
  "periods_of_day": {
    "afternoon": "12:00:00",
    "end_of_day": "21:00:00",
    "evening": "18:00:00",
    "morning": "08:00:00"
  },
  "pinned_metrics_count_map": {
    "property1": 0,
    "property2": 0
  },
  "selected_calendar_vendor_ids": [
    "string"
  ],
  "selected_metrics": [
    "string"
  ],
  "selected_metrics_map": {
    "property1": [
      "string"
    ],
    "property2": [
      "string"
    ]
  },
  "timezone": "string"
}

POST /user/v1alpha1/preferences

Set current preferences for the authenticated Fulcra user

Request

Request Body
{
  "calendar_events_data_track_filter_map": {
    "property1": [
      "string"
    ],
    "property2": [
      "string"
    ]
  },
  "calendars": [
    "string"
  ],
  "location_resolution": {
    "property1": 0,
    "property2": 0
  },
  "periods_of_day": {
    "afternoon": "12:00:00",
    "end_of_day": "21:00:00",
    "evening": "18:00:00",
    "morning": "08:00:00"
  },
  "pinned_metrics_count_map": {
    "property1": 0,
    "property2": 0
  },
  "selected_calendar_vendor_ids": [
    "string"
  ],
  "selected_metrics": [
    "string"
  ],
  "selected_metrics_map": {
    "property1": [
      "string"
    ],
    "property2": [
      "string"
    ]
  },
  "timezone": "string"
}
Parameters
Name In Type Required Description
body body FulcraUserPreferences true none

Responses

Status Meaning Description Schema
200 OK Successful Response FulcraUserPreferences
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request POST \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/preferences \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}' \
  --header 'Content-Type: application/json' \
  --data '{"calendar_events_data_track_filter_map":{"property1":["string"],"property2":["string"]},"calendars":["string"],"location_resolution":{"property1":0,"property2":0},"periods_of_day":{"afternoon":"12:00:00","end_of_day":"21:00:00","evening":"18:00:00","morning":"08:00:00"},"pinned_metrics_count_map":{"property1":0,"property2":0},"selected_calendar_vendor_ids":["string"],"selected_metrics":["string"],"selected_metrics_map":{"property1":["string"],"property2":["string"]},"timezone":"string"}'

Response Example

200 Response

{
  "calendar_events_data_track_filter_map": {
    "property1": [
      "string"
    ],
    "property2": [
      "string"
    ]
  },
  "calendars": [
    "string"
  ],
  "location_resolution": {
    "property1": 0,
    "property2": 0
  },
  "periods_of_day": {
    "afternoon": "12:00:00",
    "end_of_day": "21:00:00",
    "evening": "18:00:00",
    "morning": "08:00:00"
  },
  "pinned_metrics_count_map": {
    "property1": 0,
    "property2": 0
  },
  "selected_calendar_vendor_ids": [
    "string"
  ],
  "selected_metrics": [
    "string"
  ],
  "selected_metrics_map": {
    "property1": [
      "string"
    ],
    "property2": [
      "string"
    ]
  },
  "timezone": "string"
}

Tags


GET /user/v1alpha1/tag

Return a collection of a Fulcra User's configured tags

Responses

Status Meaning Description Schema
200 OK Successful Response Inline
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/tag \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

[
  {
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "name": "string"
  }
]

POST /user/v1alpha1/tag

Create a new tag for a Fulcra User

Request

Request Body
{
  "name": "string"
}
Parameters
Name In Type Required Description
body body CreateFulcraTagRequest true none

Responses

Status Meaning Description Schema
303 See Other Successful Response None
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request POST \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/tag \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}' \
  --header 'Content-Type: application/json' \
  --data '{"name":"string"}'

Response Example

422 Response

{
  "detail": [
    {
      "ctx": {},
      "input": null,
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

DELETE /user/v1alpha1/tag/id/{tag_id}

Deletes a tag

Request

Parameters
Name In Type Required Description
tag_id path string(uuid) true none

Responses

Status Meaning Description Schema
204 No Content Successful Response None
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request DELETE \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/tag/id/497f6eca-6276-4993-bfeb-53cbbbba6f08 \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

422 Response

{
  "detail": [
    {
      "ctx": {},
      "input": null,
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

GET /user/v1alpha1/tag/id/{tag_id}

Returns information on a Fulcra User's configured tag by tag ID

Request

Parameters
Name In Type Required Description
tag_id path string(uuid) true none

Responses

Status Meaning Description Schema
200 OK Successful Response FulcraTag
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/tag/id/497f6eca-6276-4993-bfeb-53cbbbba6f08 \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "name": "string"
}

GET /user/v1alpha1/tag/name/{tag_name}

Returns information on a Fulcra User's configured tag by tag name

Request

Parameters
Name In Type Required Description
tag_name path string true none

Responses

Status Meaning Description Schema
200 OK Successful Response FulcraTag
422 Unprocessable Entity Validation Error HTTPValidationError

Examples

Request Example

curl --request GET \
  --url https://api-dev.fulcradynamics.com/user/v1alpha1/tag/name/string \
  --header 'Accept: application/json' \
  --header 'Authorization: Bearer {access-token}'

Response Example

200 Response

{
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "name": "string"
}

Schemas

AggregateFunction

"sum"

AggregateFunction

Properties

Name Type Required Restrictions Description
AggregateFunction string false none none

Enumerated Values

Property Value
AggregateFunction sum
AggregateFunction avg
AggregateFunction min
AggregateFunction max

AggregateResolution

"15m"

AggregateResolution

Properties

Name Type Required Restrictions Description
AggregateResolution string false none none

Enumerated Values

Property Value
AggregateResolution 15m
AggregateResolution 60m
AggregateResolution day

AnnotationRoot

{
  "annotation_type": "boolean",
  "description": "string",
  "measurement_spec": {
    "boolean": {
      "value": true
    },
    "measurement_type": "boolean",
    "metric_kind": "cumulative",
    "unit": null,
    "value_type": "boolean"
  },
  "name": "string",
  "spec": {
    "default_note": "string"
  },
  "tags": [
    "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  ]
}

AnnotationRoot

Properties

Name Type Required Restrictions Description
AnnotationRoot any false none none

oneOf

Name Type Required Restrictions Description
anonymous BooleanAnnotation false none Represents an annotation with a yes or no measurement

xor

Name Type Required Restrictions Description
anonymous DurationAnnotation false none Represents an annotation with a time interval measurement

xor

Name Type Required Restrictions Description
anonymous MomentAnnotation false none Represents an annotation with no measurement

xor

Name Type Required Restrictions Description
anonymous NumericAnnotation false none Represents an annotation with a quantitative property measurement

xor

Name Type Required Restrictions Description
anonymous PeopleAnnotation false none Represents an annotation recording contact with other people

xor

Name Type Required Restrictions Description
anonymous ScaleAnnotation false none Represents an annotation with a fixed scale measurement and customizable display

AnnotationRow

{
  "annotation_type": "duration",
  "created_at": "2019-08-24T14:15:22Z",
  "deleted_at": "2019-08-24T14:15:22Z",
  "description": "string",
  "fulcra_source_id": "string",
  "fulcra_userid": "6e1fcc12-f3a1-4884-be2b-1cd76a63afb7",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "measurement_spec": {
    "boolean": {
      "value": true
    },
    "measurement_type": "boolean",
    "metric_kind": "cumulative",
    "unit": null,
    "value_type": "boolean"
  },
  "name": "string",
  "spec": {
    "default_note": "string",
    "scale": {
      "label_mapping": {
        "mapping_type": "string",
        "string": {
          "mapping": {
            "property1": "string",
            "property2": "string"
          }
        }
      },
      "scale_mapping": {
        "color": {
          "mapping": {
            "property1": "string",
            "property2": "string"
          }
        },
        "mapping_type": "color"
      }
    }
  },
  "tags": [
    "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  ],
  "updated_at": "2019-08-24T14:15:22Z"
}

AnnotationRow

Properties

Name Type Required Restrictions Description
annotation_type AnnotationType true none Annotation type
created_at string(date-time) true none none
deleted_at any false none none

anyOf

Name Type Required Restrictions Description
» anonymous string(date-time) false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
description string true none Description
fulcra_source_id string true read-only none
fulcra_userid string(uuid) true none none
id string(uuid) true none none
measurement_spec any false none Measurement spec

anyOf - discriminator: measurement_type

Name Type Required Restrictions Description
» anonymous any false none none

oneOf

Name Type Required Restrictions Description
»» anonymous BooleanMeasurement false none Represents a yes or no measurement configuration

xor

Name Type Required Restrictions Description
»» anonymous CountMeasurement false none Represents a count measurement configuration

xor

Name Type Required Restrictions Description
»» anonymous CustomMeasurement false none Represents a custom non-convertable measurement configuration

xor

Name Type Required Restrictions Description
»» anonymous DistanceMeasurement false none Represents a distance or length measurement configuration

xor

Name Type Required Restrictions Description
»» anonymous DurationMeasurement false none Represents a time duration measurement configuration

xor

Name Type Required Restrictions Description
»» anonymous MassMeasurement false none Represents a mass measurement configuration and may be inferred from weight

xor

Name Type Required Restrictions Description
»» anonymous PercentMeasurement false none Represents a percentage measurement configuration

xor

Name Type Required Restrictions Description
»» anonymous PeriodMeasurement false none Represents a time period measurement configuration

xor

Name Type Required Restrictions Description
»» anonymous ScaleMeasurement false none Represents a discrete scale measurement configuration with minimum and maximum values

xor

Name Type Required Restrictions Description
»» anonymous TemperatureMeasurement false none Represents a temperature measurement configuration

xor

Name Type Required Restrictions Description
»» anonymous VolumeMeasurement false none Represents a physical volume measurement configuration

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
name string true none Name
spec any false none Type-specific spec

anyOf

Name Type Required Restrictions Description
» anonymous ScaleAnnotationSpecContainer-Output false none none

or

Name Type Required Restrictions Description
» anonymous AnnotationSpecContainer false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
tags [string] true none Default tags
updated_at string(date-time) true none none

AnnotationSpecContainer

{
  "default_note": "string"
}

AnnotationSpecContainer

Properties

Name Type Required Restrictions Description
default_note any false none Default note text, if any

anyOf

Name Type Required Restrictions Description
» anonymous string false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

AnnotationType

"duration"

AnnotationType

Properties

Name Type Required Restrictions Description
AnnotationType string false none Represents the base type of an annotation

Enumerated Values

Property Value
AnnotationType duration
AnnotationType moment
AnnotationType numeric
AnnotationType people
AnnotationType scale
AnnotationType boolean

BaseModel

{}

BaseModel

Properties

None

BooleanAnnotation

{
  "annotation_type": "boolean",
  "description": "string",
  "measurement_spec": {
    "boolean": {
      "value": true
    },
    "measurement_type": "boolean",
    "metric_kind": "cumulative",
    "unit": null,
    "value_type": "boolean"
  },
  "name": "string",
  "spec": {
    "default_note": "string"
  },
  "tags": [
    "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  ]
}

BooleanAnnotation

Properties

Name Type Required Restrictions Description
annotation_type string false none none
description string true none Description
measurement_spec BooleanMeasurement true none Represents a yes or no measurement configuration
name string true none Name
spec any false none none

anyOf

Name Type Required Restrictions Description
» anonymous AnnotationSpecContainer false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
tags [string] true none Default tags

BooleanMeasurement

{
  "boolean": {
    "value": true
  },
  "measurement_type": "boolean",
  "metric_kind": "cumulative",
  "unit": null,
  "value_type": "boolean"
}

BooleanMeasurement

Properties

Name Type Required Restrictions Description
boolean BooleanMeasurementSpec true none none
measurement_type string false none none
metric_kind MetricKind false none How the measurement should be aggregated
unit null false none none
value_type string false none none

BooleanMeasurementSpec

{
  "value": true
}

BooleanMeasurementSpec

Properties

Name Type Required Restrictions Description
value any false none Default value

anyOf

Name Type Required Restrictions Description
» anonymous boolean false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

BoundsResponse

{
  "end_date": "2019-08-24T14:15:22Z",
  "start_date": "2019-08-24T14:15:22Z"
}

BoundsResponse

Properties

Name Type Required Restrictions Description
end_date any true none the ending date/time of this data set

anyOf

Name Type Required Restrictions Description
» anonymous string(date-time) false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
start_date any true none the starting date/time of this data set

anyOf

Name Type Required Restrictions Description
» anonymous string(date-time) false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

ColorScaleMapping-Input

{
  "color": {
    "mapping": {
      "property1": "string",
      "property2": "string"
    }
  },
  "mapping_type": "color"
}

ColorScaleMapping

Properties

Name Type Required Restrictions Description
color ColorScaleMappingSpec-Input true none none
mapping_type string false none none

ColorScaleMapping-Output

{
  "color": {
    "mapping": {
      "property1": "string",
      "property2": "string"
    }
  },
  "mapping_type": "color"
}

ColorScaleMapping

Properties

Name Type Required Restrictions Description
color ColorScaleMappingSpec-Output true none none
mapping_type string false none none

ColorScaleMappingSpec-Input

{
  "mapping": {
    "property1": "string",
    "property2": "string"
  }
}

ColorScaleMappingSpec

Properties

Name Type Required Restrictions Description
mapping object true none Mapping of scale values to colors, normalized to hex format
» additionalProperties string(color) false none none

ColorScaleMappingSpec-Output

{
  "mapping": {
    "property1": "string",
    "property2": "string"
  }
}

ColorScaleMappingSpec

Properties

Name Type Required Restrictions Description
mapping object true none Mapping of scale values to colors, normalized to hex format
» additionalProperties string false none none

CountMeasurement

{
  "count": {
    "value": 0
  },
  "measurement_type": "count",
  "metric_kind": "cumulative",
  "unit": null,
  "value_type": "real"
}

CountMeasurement

Properties

Name Type Required Restrictions Description
count CountMeasurementSpec true none none
measurement_type string false none none
metric_kind MetricKind false none How the measurement should be aggregated
unit null false none none
value_type string false none none

CountMeasurementSpec

{
  "value": 0
}

CountMeasurementSpec

Properties

Name Type Required Restrictions Description
value any false none Default value

anyOf

Name Type Required Restrictions Description
» anonymous number false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

CreateDataTypeBody

{
  "api_version": "string",
  "categories": [
    "string"
  ],
  "column_name": "string",
  "deprecated": true,
  "description": "string",
  "icon": "string",
  "id": "string",
  "metadata": {
    "property1": null,
    "property2": null
  },
  "name": "string",
  "queryable": true,
  "record_spec": {
    "aggregation": "cumulative",
    "scale": {
      "max": 0,
      "min": 0,
      "step": 0
    },
    "schema": "string",
    "type": "string",
    "unit": "string",
    "value_map": {
      "property1": "string",
      "property2": "string"
    }
  },
  "recordable": true
}

Properties

Name Type Required Restrictions Description
api_version string false none none
categories array,null false none none
column_name string false none none
deprecated boolean false none none
description string true none none
icon string false none none
id string false none none
metadata object false none none
» additionalProperties any false none none
name string true none none
queryable boolean false none none
record_spec RecordSpecInput false none none
recordable boolean false none none

CreateFileUploadRequestBody

{
  "content_length": 0,
  "content_type": "string",
  "name": "string",
  "path": "string"
}

Properties

Name Type Required Restrictions Description
content_length integer(int64) true none none
content_type string true none none
name string true none none
path string true none none

CreateFileUploadResponseBody

{
  "file": {
    "archived_at": "2019-08-24T14:15:22Z",
    "created_at": "2019-08-24T14:15:22Z",
    "deleted_at": "2019-08-24T14:15:22Z",
    "fulcra_userid": "string",
    "id": "string",
    "last_scanned": "2019-08-24T14:15:22Z",
    "name": "string",
    "path": "string",
    "restored_from_id": "string",
    "scan_state": "string",
    "size": 0,
    "source_data_types": [
      {
        "data_type": "string",
        "state": "string"
      }
    ],
    "source_id": "string",
    "source_name": "string",
    "state": "string",
    "uploaded_at": "2019-08-24T14:15:22Z"
  },
  "url": "string"
}

Properties

Name Type Required Restrictions Description
file FulcraFileUploadInput true none none
url string true none none

CreateFulcraCustomInputRequest

{
  "default_event_tags": [
    "string"
  ],
  "description": "string",
  "fulcra_data_type": "string",
  "fulcra_source": [
    "string"
  ],
  "name": "string"
}

Properties

Name Type Required Restrictions Description
default_event_tags array,null false none none
description string,null false none none
fulcra_data_type string,null false none none
fulcra_source array,null false none none
name string true none none

CreateFulcraReflectionRequest

{
  "annotations": [],
  "data_types": [],
  "description": "string",
  "name": "string",
  "parent_template_id": "string",
  "schedule": {
    "cron": "string",
    "end_at": "string",
    "paused": true,
    "start_at": "string",
    "time_zone": "string"
  }
}

Properties

Name Type Required Restrictions Description
annotations array,null false none none
data_types array,null false none none
description string false none none
name string true none none
parent_template_id string false none none
schedule FulcraReflectionSchedule true none none

CreateFulcraTagRequest

{
  "name": "string"
}

CreateFulcraTagRequest

Properties

Name Type Required Restrictions Description
name string true none none

CustomFulcraDataType

{
  "api_version": "v0",
  "categories": [
    "annotations"
  ],
  "class": "metric",
  "column_name": "string",
  "deprecated": false,
  "description": "string",
  "fulcra_userid": "6e1fcc12-f3a1-4884-be2b-1cd76a63afb7",
  "icon": "string",
  "id": "string",
  "metric_kind": "cumulative",
  "name": "string",
  "queryable": true,
  "record_spec": {
    "schema": {},
    "type": "event"
  },
  "recordable": true,
  "unit": "string"
}

CustomFulcraDataType

Properties

Name Type Required Restrictions Description
api_version FulcraAPIVersion true none Fulcra API version
categories [FulcraCategory] true none Categories this data type belongs to
class FulcraRecordType true none Fulcra record types
column_name string true none Name of data column as returned by Fulcra APIs
deprecated boolean false none Whether this type is deprecated
description string true none Human-readable description
fulcra_userid string(uuid) true none none
icon any false none Icon identifier

anyOf

Name Type Required Restrictions Description
» anonymous string false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
id string true none Programmatic Identifier
metric_kind any true read-only none

anyOf

Name Type Required Restrictions Description
» anonymous FulcraMetricAggregation false none fulcra metric aggregation

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
name string true none Human-readable name
queryable boolean false none Denotes if this type can be queried
record_spec any true none Metadata about the data that is recorded and queried

oneOf

Name Type Required Restrictions Description
» anonymous FulcraEventRecord false none spec metadata for a fulcra event record

xor

Name Type Required Restrictions Description
» anonymous FulcraMetricRecord false none represents the type or 'shape' of a record for a fulcra data type

xor

Name Type Required Restrictions Description
» anonymous FulcraLocationRecord false none spec metadata for a fulcra location record

xor

Name Type Required Restrictions Description
» anonymous FulcraTombstoneRecord false none spec metadata for a fulcra tombstone (aka deleted record)

continued

Name Type Required Restrictions Description
recordable boolean false none Denotes if this type can be recorded
unit any true read-only none

anyOf

Name Type Required Restrictions Description
» anonymous string false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

CustomMeasurement

{
  "custom": {
    "value": 0
  },
  "measurement_type": "custom",
  "metric_kind": "cumulative",
  "unit": "string",
  "value_type": "real"
}

CustomMeasurement

Properties

Name Type Required Restrictions Description
custom CustomMeasurementSpec true none none
measurement_type string false none none
metric_kind MetricKind false none How the measurement should be aggregated
unit any false none none

anyOf

Name Type Required Restrictions Description
» anonymous string false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
value_type string false none none

CustomMeasurementSpec

{
  "value": 0
}

CustomMeasurementSpec

Properties

Name Type Required Restrictions Description
value any false none Default value

anyOf

Name Type Required Restrictions Description
» anonymous number false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

DataMetric

{
  "description": "string",
  "is_time_series": false,
  "metric_kind": "string",
  "name": "string",
  "unit": "string",
  "value_column": "string"
}

DataMetric

Properties

Name Type Required Restrictions Description
description string true none A human-readable description of the metric.
is_time_series boolean false none This is true when the metric is a time-series metric.
metric_kind any false none The kind of metric.

anyOf

Name Type Required Restrictions Description
» anonymous string false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
name string true none The name of the metric.
unit string true none The measurement unit of the value column.
value_column string true none The name of the value column in the resulting dataframe.

DataRecordMetadataV1

{
  "content_type": "string",
  "data_type": "string",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "recorded_at": "2019-08-24T14:15:22Z",
  "source": [],
  "tags": []
}

DataRecordMetadataV1

Properties

Name Type Required Restrictions Description
content_type any false none none

anyOf

Name Type Required Restrictions Description
» anonymous string false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
data_type string true none none
id any false none none

anyOf

Name Type Required Restrictions Description
» anonymous string(uuid) false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
recorded_at any false none none

anyOf

Name Type Required Restrictions Description
» anonymous string(date-time) false none none

or

Name Type Required Restrictions Description
» anonymous DateTimeRange false none none

continued

Name Type Required Restrictions Description
source [string] false none none
tags [string] false none none

DataRecordV1

{
  "data": "string",
  "metadata": {
    "content_type": "string",
    "data_type": "string",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "recorded_at": "2019-08-24T14:15:22Z",
    "source": [],
    "tags": []
  },
  "specversion": 1
}

DataRecordV1

Properties

Name Type Required Restrictions Description
data string true none none
metadata DataRecordMetadataV1 true none none
specversion integer false none none

DataTypeSpec

{
  "api_version": "string",
  "categories": [
    "string"
  ],
  "column_name": "string",
  "deprecated": true,
  "description": "string",
  "icon": "string",
  "id": "string",
  "metadata": {
    "property1": null,
    "property2": null
  },
  "name": "string",
  "queryable": true,
  "record_spec": {
    "aggregation": "string",
    "scale": {
      "max": 0,
      "min": 0,
      "step": 0
    },
    "schema": "string",
    "type": "string",
    "unit": "string",
    "value_map": {
      "property1": "string",
      "property2": "string"
    }
  },
  "recordable": true
}

Properties

Name Type Required Restrictions Description
api_version string true none none
categories array,null true none none
column_name string false none none
deprecated boolean true none none
description string true none none
icon string false none none
id string false none none
metadata object true none none
» additionalProperties any false none none
name string true none none
queryable boolean true none none
record_spec RecordSpec true none none
recordable boolean true none none

DateTimeRange

{
  "end_time": "2019-08-24T14:15:22Z",
  "start_time": "2019-08-24T14:15:22Z"
}

DateTimeRange

Properties

Name Type Required Restrictions Description
end_time string(date-time) true none none
start_time string(date-time) true none none

DeployPlatform

"vercel"

DeployPlatform

Properties

Name Type Required Restrictions Description
DeployPlatform string false none none

Enumerated Values

Property Value
DeployPlatform vercel

DeployProject

{
  "created_at": "2019-08-24T14:15:22Z",
  "domain": "string",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "name": "string",
  "platform": "vercel",
  "platform_project_id": "string"
}

DeployProject

Properties

Name Type Required Restrictions Description
created_at string(date-time) true none none
domain string true none none
id string(uuid) true none none
name string true none none
platform DeployPlatform true none none
platform_project_id string true none none

DeployProjectCreate

{
  "framework": "string",
  "name": "string"
}

DeployProjectCreate

Properties

Name Type Required Restrictions Description
framework any false none Platform framework preset, e.g. nextjs or vite

anyOf

Name Type Required Restrictions Description
» anonymous string false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
name string true none none

DeployProjectToken

{
  "expires_at": "2019-08-24T14:15:22Z",
  "platform": "vercel",
  "platform_project_id": "string",
  "platform_team_id": "string",
  "token": "string"
}

DeployProjectToken

Properties

Name Type Required Restrictions Description
expires_at string(date-time) true none none
platform DeployPlatform true none none
platform_project_id string true none none
platform_team_id string true none Team that owns the project, needed to deploy with the platform CLI (e.g. VERCEL_ORG_ID)
token string true none none

DistanceMeasurement

{
  "distance": {
    "value": 0
  },
  "measurement_type": "distance",
  "metric_kind": "cumulative",
  "unit": "inch",
  "value_type": "real"
}

DistanceMeasurement

Properties

Name Type Required Restrictions Description
distance DistanceMeasurementSpec true none none
measurement_type string false none none
metric_kind MetricKind false none How the measurement should be aggregated
unit any false none none

anyOf

Name Type Required Restrictions Description
» anonymous DistanceUnit false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
value_type string false none none

DistanceMeasurementSpec

{
  "value": 0
}

DistanceMeasurementSpec

Properties

Name Type Required Restrictions Description
value any false none Default value

anyOf

Name Type Required Restrictions Description
» anonymous number false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

DistanceUnit

"inch"

DistanceUnit

Properties

Name Type Required Restrictions Description
DistanceUnit string false none none

Enumerated Values

Property Value
DistanceUnit inch
DistanceUnit foot
DistanceUnit yard
DistanceUnit mile
DistanceUnit millimeter
DistanceUnit centimeter
DistanceUnit meter
DistanceUnit kilometer

DurationAnnotation

{
  "annotation_type": "duration",
  "description": "string",
  "measurement_spec": {
    "measurement_type": "duration",
    "metric_kind": "cumulative",
    "unit": null,
    "value_type": "duration"
  },
  "name": "string",
  "spec": {
    "default_note": "string"
  },
  "tags": [
    "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  ]
}

DurationAnnotation

Properties

Name Type Required Restrictions Description
annotation_type string false none none
description string true none Description
measurement_spec DurationMeasurement true none Represents a time duration measurement configuration
name string true none Name
spec any false none none

anyOf

Name Type Required Restrictions Description
» anonymous AnnotationSpecContainer false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
tags [string] true none Default tags

DurationMeasurement

{
  "measurement_type": "duration",
  "metric_kind": "cumulative",
  "unit": null,
  "value_type": "duration"
}

DurationMeasurement

Properties

Name Type Required Restrictions Description
measurement_type string false none none
metric_kind MetricKind false none How the measurement should be aggregated
unit null false none none
value_type string false none none

EmojiScaleMapping-Input

{
  "color": {
    "mapping": {
      "property1": "string",
      "property2": "string"
    }
  },
  "mapping_type": "emoji",
  "string": {
    "mapping": {
      "property1": "string",
      "property2": "string"
    }
  }
}

EmojiScaleMapping

Properties

Name Type Required Restrictions Description
color ColorScaleMappingSpec-Input true none none
mapping_type string false none none
string StringScaleMappingSpec true none none

EmojiScaleMapping-Output

{
  "color": {
    "mapping": {
      "property1": "string",
      "property2": "string"
    }
  },
  "mapping_type": "emoji",
  "string": {
    "mapping": {
      "property1": "string",
      "property2": "string"
    }
  }
}

EmojiScaleMapping

Properties

Name Type Required Restrictions Description
color ColorScaleMappingSpec-Output true none none
mapping_type string false none none
string StringScaleMappingSpec true none none

ErrorDetail

{
  "location": "string",
  "message": "string",
  "value": null
}

Properties

Name Type Required Restrictions Description
location string false none Where the error occurred, e.g. 'body.items[3].tags' or 'path.thing-id'
message string false none Error message text
value any false none The value at the given location

ErrorModel

{
  "detail": "Property foo is required but is missing.",
  "errors": [
    {
      "location": "string",
      "message": "string",
      "value": null
    }
  ],
  "instance": "https://example.com/error-log/abc123",
  "status": 400,
  "title": "Bad Request",
  "type": "https://example.com/errors/example"
}

Properties

Name Type Required Restrictions Description
detail string false none A human-readable explanation specific to this occurrence of the problem.
errors array,null false none Optional list of individual error details
instance string(uri) false none A URI reference that identifies the specific occurrence of the problem.
status integer(int64) false none HTTP status code
title string false none A short, human-readable summary of the problem type. This value should not change between occurrences of the error.
type string(uri) false none A URI reference to human-readable documentation for the error.

FulcraAPISessionRow

{
  "created_at": "2019-08-24T14:15:22Z",
  "deleted_at": "2019-08-24T14:15:22Z",
  "fulcra_userid": "6e1fcc12-f3a1-4884-be2b-1cd76a63afb7",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "name": "string",
  "policy_id": "ee9b03e0-6495-427a-85a5-34444d24ae04"
}

FulcraAPISessionRow

Properties

Name Type Required Restrictions Description
created_at string(date-time) true none none
deleted_at any true none none

anyOf

Name Type Required Restrictions Description
» anonymous string(date-time) false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
fulcra_userid string(uuid) true none none
id string(uuid) true none none
name string true none none
policy_id any false none none

anyOf

Name Type Required Restrictions Description
» anonymous string(uuid) false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

FulcraAPIVersion

"v0"

FulcraAPIVersion

Properties

Name Type Required Restrictions Description
FulcraAPIVersion string false none fulcra API versions

Enumerated Values

Property Value
FulcraAPIVersion v0
FulcraAPIVersion v1alpha1
FulcraAPIVersion v1

FulcraAppleWorkout

{
  "all_statistics": {},
  "apple_workout_id": "17d1ac31-161c-41b7-bb0c-8c7db70b55d8",
  "device": {},
  "duration": 0,
  "end_date": "2019-08-24T14:15:22Z",
  "extras": {},
  "has_undetermined_duration": true,
  "source_revision": {},
  "start_date": "2019-08-24T14:15:22Z",
  "workout_activities": [
    {}
  ],
  "workout_activity_type": "The type of workout.",
  "workout_events": [
    {}
  ]
}

FulcraAppleWorkout

Properties

Name Type Required Restrictions Description
all_statistics object true none A collection of descriptive statistics for the workout.
apple_workout_id string(uuid) true none Workout ID
device any true none Details of the device that recorded the workout,

anyOf

Name Type Required Restrictions Description
» anonymous object false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
duration number true none Length of the workout (seconds)
end_date string(date-time) true none the date/time when this workout ends
extras any true none Extra values that are not (yet) accounted for in the schema.

anyOf

Name Type Required Restrictions Description
» anonymous object false none none

or

Name Type Required Restrictions Description
» anonymous null false none none

continued

Name Type Required Restrictions Description
has_undetermined_duration boolean true none indicates whether or not this workout has an unknown duration
source_revision object true none Details of the source application or device that recorded the workout.
start_date string(date-time) true none the date/time when this workout starts
[...]
